// sprtf.cxx
#include "testmem.h"

#define  MXIO     256
char def_log[] = "temptemp.txt";
char logfile[256] = "\0";
FILE * outfile = NULL;
static int addsystime = 0;
static int addstdout = 0;

int   add_std_out( int val )
{
   int i = addstdout;
   addstdout = val;
   return i;
}

int   add_sys_time( int val )
{
   int   i = addsystime;
   addsystime = val;
   return i;
}

int   open_log_file( void )
{
   if (logfile[0] == 0)
      strcpy(logfile,def_log);
   outfile = fopen(logfile, "wb");
   if( outfile == 0 ) {
      outfile = (FILE *)-1;
      printf("WARNING: Failed to open log file [%s] ...\n", logfile);
      return 0;   /* failed */
   }
   return 1; /* success */
}

void close_log_file( void )
{
   if( VFP(outfile) ) {
      fclose(outfile);
   }
   outfile = NULL;
}
char * get_log_file( void )
{
   if (logfile[0] == 0)
      strcpy(logfile,def_log);
   return logfile;
}

void   set_log_file( char * nf )
{
   if (logfile[0] == 0)
      strcpy(logfile,def_log);
   if ( nf && *nf && strcmpi(nf,logfile) ) {
      close_log_file(); // remove any previous
      strcpy(logfile,nf); // set new name
      open_log_file();  // and open it ... anything previous written is 'lost'
   }
}

static void oi( char * psin )
{
   char * ps = psin;
   int len = (int)strlen(ps);
   if(len) {
      if( outfile == 0 ) {
         open_log_file();
      }
#ifdef   ADD_SYSTEM_TIME
      if( addsystime ) {
         SYSTEMTIME st;
         GetLocalTime( &st );
         ps = GetNxtBuf();
         len = sprintf( ps, "%2d:%02d:%02d - %s", st.wHour & 0xffff,
            st.wMinute & 0xffff, st.wSecond & 0xffff, psin );
      }
#endif // #ifdef   ADD_SYSTEM_TIME
      if( VFP(outfile) ) {
         int w;
         w = (int)fwrite( ps, 1, len, outfile );
         if( w != len ) {
            fclose(outfile);
            outfile = (FILE *)-1;
            printf("WARNING: Failed write to log file [%s] ...\n", logfile);
         }
      }
      if( addstdout ) {
         fwrite( ps, 1, len, stdout );
      }
   }
}

void my_prt( char * ps )
{
   static char buf[MXIO + 16];
	char * pb = buf;
	size_t i, j, k;
	char   c, d;
   i = strlen(ps);
	if(i) {
		k = 0;
		d = 0;
		for( j = 0; j < i; j++ )
		{
			c = ps[j];
			if( c == 0x0d ) {
				if( (j+1) < i ) {
					if( ps[j+1] != 0x0a ) {
						pb[k++] = c;
						c = 0x0a;
					}
            } else {
					pb[k++] = c;
					c = 0x0a;
				}
			} else if( c == 0x0a ) {
				if( d != 0x0d ) {
					pb[k++] = 0x0d;
				}
			}
			pb[k++] = c;
			d = c;
			if( k >= MXIO ) {
				pb[k] = 0;
				oi( pb );
				k = 0;
			}
		}	// for length of string
		if( k ) {
			//if( ( gbCheckCrLf ) &&
			//	( d != 0x0a ) ) {
				// add Cr/Lf pair
				//pb[k++] = 0x0d;
				//pb[k++] = 0x0a;
				//pb[k] = 0;
			//}
			pb[k] = 0;
			oi( pb );
		}
	}
}

int _cdecl sprtf( char * pf, ... )
{
   static char _s_sprtfbuf[1024];
   char * pb = _s_sprtfbuf;
   int   i;
   va_list arglist;
   va_start(arglist, pf);
   i = vsprintf( pb, pf, arglist );
   va_end(arglist);
   my_prt(pb);
   return i;
}

// eof - sprtf.cxx
