// testmem.cpp : Defines the entry point for the application.
//

#include "testmem.h"
#include "showrt.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

// _CRTDBG_CHECK_CRT_DF
#define  NewFlag ( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF )
//#define  NewFlag ( _CRTDBG_CHECK_CRT_DF | _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF )

PVOID pVoid1 = 0;
PVOID pVoid2 = 0;
PVOID pVoid3 = 0;
PVOID pVoid4 = 0;
PVOID pVoid5 = 0;

#define  SHOWMEM1(a) sprtf( "%s(%d): using " a , __FILE__, __LINE__ + 1 )
#define  SHOWMEM2(a,b) sprintf((char *)a, "%p %s", a, b); sprtf( " %s\n", a)

VOID Allocate_using_new(VOID)
{
   SHOWMEM1( "new BYTE[1234] " );
   pVoid1 = new BYTE[1234];
   SHOWMEM2(pVoid1,"new");
}
VOID Allocate_using_malloc(VOID)
{
   SHOWMEM1( "malloc 4567 " );
   pVoid2 = malloc(4567);
   SHOWMEM2(pVoid2,"malloc");
}

VOID Allocate_using_LocalAlloc(VOID)
{
   SHOWMEM1( "LocalAlloc 2345 " );
   pVoid3 = LocalAlloc( LPTR, 2345 );
   SHOWMEM2(pVoid3,"LocalAlloc");
}
VOID Allocate_using_VirtualAlloc(VOID)
{
   SHOWMEM1( "VirtualAlloc 3 MB " );
   pVoid4 = VirtualAlloc( NULL, 3 * 1024, MEM_COMMIT, PAGE_READWRITE );
   SHOWMEM2(pVoid4,"VirtualAlloc");
}

VOID Allocate_using_GlobalAlloc(VOID)
{
   SHOWMEM1( "GlobalAlloc 3456 " );
   pVoid5 = GlobalAlloc( GPTR, 3456 );
   SHOWMEM2(pVoid5,"GlobalAlloc");
}

VOID Allocate_Test_Memory( VOID )
{
   sprtf( "Allocations made in MAIN module: %s ...\n", __FILE__ );
   Allocate_using_new();
   Allocate_using_malloc();
   Allocate_using_LocalAlloc();
   Allocate_using_GlobalAlloc();
   Allocate_using_VirtualAlloc();
}

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

   _CrtSetDbgFlag( NewFlag );

   sprtf( "RUNTIME: %s\n", RTMESS );
   // local MAIN allocations
   Allocate_Test_Memory();

   // in DLL allocations
#ifdef USE_LINKED_LIST
   PLE ph = fnMemTestDLL();
   PLE pn;
   Traverse_List(ph,pn)
   {
      PMYLINES pml = (PMYLINES)pn;
      my_prt( &pml->line[0] );
   }
   fnMemTestDLLClear();
#else // !USE_LINKED_LIST
   char * pb = fnMemTestDLL();
   my_prt(pb);
#endif // USE_LINKED_LIST

   // in STATIC allocation
   fnMemTestStatic();

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_TESTMEM, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_TESTMEM);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_TESTMEM);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCTSTR)IDC_TESTMEM;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}
